/*
 * Licensed to the OpenAirInterface (OAI) Software Alliance under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The OpenAirInterface Software Alliance licenses this file to You under
 * the OAI Public License, Version 1.1  (the "License"); you may not use this file
 * except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.openairinterface.org/?page_id=698
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *-------------------------------------------------------------------------------
 * For more information about the OpenAirInterface (OAI) Software Alliance:
 *      contact@openairinterface.org
 */



#ifndef SM_ALLOCATION_H
#define SM_ALLOCATION_H

////////////////////////////////////
// 5 ORAN E2AP procedures 
// defined in ORAN-WG3.E2SM-v01.00.00  
///////////////////////////////////

// (De)Allocation of the messages generated by the Service Models


#include <stddef.h> 
#include <stdint.h>

typedef struct{

  void (*free_subs_data_msg)(void* msg);

  void (*free_ind_data)(void* msg);

  void (*free_ctrl_out_data)(void* msg);

  void (*free_ctrl_req_data)(void* msg);

  void (*free_e2_setup)(void* msg);

  void (*free_ric_service_update)(void* msg);

} sm_alloc_t;

#endif

